import 'dart:async';
import 'package:dio/dio.dart';
import 'package:dio/adapter.dart';

class DioMock extends HttpClientAdapter {
  DefaultHttpClientAdapter _adapter = DefaultHttpClientAdapter();
  String stringResponse;
  List<int> binaryResponse;
  Function(RequestOptions options, Stream<List<int>> requestStream,
      Future cancelFuture) customResponse;

  @override
  Future<ResponseBody> fetch(RequestOptions options,
      Stream<List<int>> requestStream, Future cancelFuture) async {
    if (stringResponse != null) {
      ResponseBody.fromString(stringResponse, 200);
    } else if (binaryResponse != null) {
      return ResponseBody.fromBytes(binaryResponse, 200);
    } else if (customResponse != null) {
      return customResponse(options, requestStream, cancelFuture);
    }
    return _adapter.fetch(options, requestStream, cancelFuture);
  }

  @override
  void close({bool force = false}) {
    _adapter.close(force: force);
  }
}
